#!C:/Programme/Perl/bin/
#$Id: createtable.pl,v 1.3 2005/02/16 22:20:08 boris Exp $
#
#
#
#    
#

use Getopt::Std; 

$usage = 
"Usage: createtable.pl [-d] [-s] [-t answers_file]  [-o results] \n";

require 'parameters.pl';
require 'subroutines.pl';

die $usage unless getopts('t:o:ds');

$DEBUG=$opt_d;
$SHORT=$opt_s;

my %teams;
my @answers;
my @ratings;
#
#   
#
if ($opt_t) {
    die "Cannot open $opt_t\n" unless open(INFILE,$opt_t);
} else {
   *INFILE=*STDIN;
}
    
readhash(\@answers);
close(INFILE);


#
#    
#
if ($opt_o) { 
    die "Cannot open $opt_o\n" unless open(OUTFILE,">$opt_o");
    select OUTFILE;
}

#   
$MAXQUEST=1;
for (my $i=1; $i<=$ROUNDS; $i++) {
    if ($MAXQUEST<$MAXQUEST[$i]) {
	$MAXQUEST=$MAXQUEST[$i];
    }
}


#
#      
#
for (my $r=1; $r<=$ROUNDS; $r++) {
    if ($DEBUG) {
	print STDERR " $r\n";
    }
#
#      
#

    foreach my $file (split /\s+/, $FILES[$r]) {
	open (INFILE, $file);
	readmail(\%teams);
	collect_answers(\%teams,\@answers);
	close (INFILE);
    }

#
#   
#
    rate_questions(\%teams,\@answers,\@ratings,$r);
#
#      
#
    find_scores(\%teams,\@answers,\@ratings,$r,0.01);
#
#      ...
#
#
#  
#
    print "  $NAME[$r]\n";
    printf "%5s ", "N";
    for ($i=$MINQUEST[$r];$i<=$MAXQUEST[$r];$i++)
    {
	if ($SHORT) {
	    printf("%1d",$i%10);
	} else {
	    printf "%3d",$i;
	}
    }
    printf "%6s","";
    printf "%4s","";
    printf " ";
    print "\n";
#
#   
#
    foreach $team (sort 
		   {
		       $teams{$b}->{score} <=> $teams{$a}->{score}
		       or
			   $teams{$b}->{rating} <=> $teams{$a}->{rating}
		   } keys %teams
		   )
    {
	printf "%5d ",$teams{$team}->{regnum};
	for ($i=$MINQUEST[$r];$i<=$MAXQUEST[$r];$i++)
	{
	    my $answer = $teams{$team}->{answers}[$i];
	    my $score = $answers[$i]->{$answer}->{score};
	    $score = '-' unless $score;
	    if ($SHORT) {
		printf "%1s",$score;
	    } else {
		printf "%3s", $score;
	    }
	}
	printf "%6.2f",$teams{$team}->{score};
	printf "%4s",$teams{$team}->{rating};
	print " $team";
	print "\n";
    }
#
#    
#    
#
    if ($SHORT) {
	print "\n";
	for ($j=0;$j<$MAXQUEST[$r]/12;$j++) {
	    my $max=$j*12+12;
	    if ($max>$MAXQUEST[$r]) {
		$max=$MAXQUEST[$r];
	    }
	    for ($i=$j*12+1;$i<=$max;$i++){
		printf("%3s",$i);
	    }
	    printf "\n";
	    for ($i=1+$j*12;$i<=$max;$i++){
		printf("%3s",$ratings[$i]);
	    }
	    printf "\n";
	}
    } else {
	printf "%5s ", "";
	for ($i=$MINQUEST[$r]; $i<=$MAXQUEST[$r];$i++)
	{
	    printf "%3s", $ratings[$i];
	}
	print "\n";
    }
    print "\n";
}
